﻿<template>
    <div class="content-grid content-grid--subpage">
        <Breadcrumbs :title="t(`routes.admin.children.members.add.name`)" />
        <BackLinkTitle :title="t(`routes.admin.children.members.add.name`)" />
        <Card>
            <MemberForm @formSubmit="handleSubmit" />
        </Card>
    </div>
</template>

<script lang="ts" setup>
    import Breadcrumbs from "@/components/layout/Breadcrumbs.vue";
    import BackLinkTitle from "@/components/layout/BackLinkTitle.vue";
    import MemberForm from "@/components/members/MemberForm.vue";
    import Card from "@/components/layout/Card.vue";
    import {useI18n} from "vue3-i18n";
    import {notifyError, notifySuccess} from "@/notify";
    import { useRouter } from "vue-router";
    import { Member } from "@/types/entities";
    import { useMemberService } from "@/inversify.config";
    import { ICreateMemberRequest } from "@/types/requests/createMemberRequest";

    const {t} = useI18n()
    const router = useRouter();
    const memberService = useMemberService();

    async function handleSubmit(member : Member) {
        let succeededOrNotResponse = await memberService.createMember(member as ICreateMemberRequest)
        if (succeededOrNotResponse && succeededOrNotResponse.succeeded) {
            notifySuccess(t('validation.member.add.success'))
            setTimeout(() => {
                router.back();
            }, 1500);
        } else {
            let errorMessages = succeededOrNotResponse.getErrorMessages('validation.member.add');
            if (errorMessages.length == 0)
                notifyError(t('validation.member.add.errorOccured'))
            else
                notifyError(errorMessages[0])
        }
    }
</script>
